/**************************************************************************
* DSemu - The Next Generation                                             *
* Portable ARM9ES core: Null Coprocessor [arm-cpnull.cpp]                 *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
**************************************************************************/

#include "arm-cpnull.h"

// Essentially, the null copro is exactly that; a coprocessor that does
// nothing with the data given to it. Every entry in the ARM9's copro table
// is initialised to point to the null copro, except of course #15.

ARMcpNULL::ARMcpNULL()
{
}

ARMcpNULL::~ARMcpNULL()
{
}

void ARMcpNULL::set(int op1, int op2, int rn, int rm, u32 val)
{
}

u32 ARMcpNULL::get(int op1, int op2, int rn, int rm)
{
    return 0;
}

void ARMcpNULL::op(int op1, int op2, int rn, int rm, int rd)
{
}

void ARMcpNULL::read(int rd, u32 addr, int longword, int opt)
{
}

void ARMcpNULL::write(int rd, u32 addr, int longword, int opt)
{
}

/*** EOF: arm-cpnull.cpp *************************************************/

