/**************************************************************************
* DSemu - The Next Generation                                             *
* Portable ARM cores: Useful definitions [armhelp.h]                      *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
**************************************************************************/

#ifndef __ARMHELP_H_
#define __ARMHELP_H_

#include "armmasks.h"

#define _ROR(val, shft) ((((val)&(~((1<<(shft))-1)))>>(shft)) | (((val)&((1<<(shft))-1))<<(32-(shft))))

// Register indices
#define _OP_RM ((reg.curop&MSK_RM)>>SHFT_RM)
#define _OP_RN ((reg.curop&MSK_RN)>>SHFT_RN)
#define _OP_RS ((reg.curop&MSK_RS)>>SHFT_RS)
#define _OP_RD ((reg.curop&MSK_RD)>>SHFT_RD)

#define _RM reg.r[_OP_RM]
#define _RN reg.r[_OP_RN]
#define _RS reg.r[_OP_RS]
#define _RD reg.r[_OP_RD]

// Help with the pipeline hack
#define Rn15hack ((_OP_RN==15)?4:0)
#define Rm15hack ((_OP_RM==15)?4:0)

#define helpDPshfti ((reg.curop&MSK_SHFT)>>7)
#define helpDPshftr (_RS&255)

// ROR wrapper for the load/store opcodes
#define LSror _RD=_ROR(_RD, ((reg.tmp1&3)*8)); if(_OP_RD==15) _RD&=~3

#endif//__ARMHELP_H_

/*** EOF: armhelp.h ******************************************************/

