/**************************************************************************
* DSemu - The next Generation                                             *
* Memory management: Endian neutrality functions [byteswap.h]             *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
**************************************************************************/

#ifndef __BYTESWAP_H_
#define __BYTESWAP_H_

#if BOK_BIG_ENDIAN == 1
# define htoms(x) (((x)>>8)|((x)<<8))
# define htoml(x) (((x)<<24)|(((x)&0xFF00)<<8)|(((x)&0xFF0000)>>8)|((x)>>24))
# define mtohs(x) (((x)>>8)|((x)<<8))
# define mtohl(x) (((x)<<24)|(((x)&0xFF00)<<8)|(((x)&0xFF0000)>>8)|((x)>>24))
#else
# define htoms(x) (x)
# define htoml(x) (x)
# define mtohs(x) (x)
# define mtohl(x) (x)
#endif//BOK_BIG_ENDIAN

#endif//__BYTESWAP_H_

/*** EOF: byteswap.h *****************************************************/

