#ifndef __CODEBLOCK_H_
#define __CODEBLOCK_H_

#include "defs.h"

typedef struct {
    u32 ARM_startaddr;    // Startpoint of the block
    u32 ARM_endaddr;      // Endpoint of the block
    u8 *target_addr;      // x86 code for this block
    u16 target_size;      // Size of x86 code block
    u16 ARM_cycles;       // Number of cycles taken by this block
    uint64_t timestamp;   // Time of last use
    u32 flags;
    u32 pad2;
} CODEBLOCK;

#define BLOCK_ARM   0
#define BLOCK_THUMB 1

#endif

