/**************************************************************************
* DSemu - The Next Generation                                             *
* Useful global definitions [defs.h]                                      *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
**************************************************************************/

#ifndef __DEFS_H_
#define __DEFS_H_

#include <stdio.h>
#include "sysdep.h"
#include "w32compile.h"

//---Maximum filename length-----------------------------------------------

#ifndef FILENAME_MAX
# define FILENAME_MAX 8192
#endif

#ifndef COMPILING_ON_WINDERZ
# define MAX_PATH FILENAME_MAX
#else
# include <windows.h>
#endif

//---Dynamic-loading C-style exports---------------------------------------

#ifdef _MSC_VER
# define EXPORTFUNC extern "C" __declspec(dllexport)
#else
# define EXPORTFUNC extern "C"
#endif

//---Function pointer typedefs---------------------------------------------

typedef void (*fptr)();
typedef void (*vfptr)(void*);

//---64-bit data types-----------------------------------------------------

#ifdef _MSC_VER
# define uint64_t unsigned __int64
# define int64_t signed __int64
#else
# include <stdint.h>
#endif

#endif//__DEFS_H_

/*** EOF: defs.h *********************************************************/

