/**************************************************************************
* DSemu - The Next Generation                                             *
* Application entry point [dsemu.cpp]                                     *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
**************************************************************************/

#include "w32compile.h"
#include "log.h"
#include "err.h"
#include "plugin.h"
#include "plggui.h"

// All the entry point does is load and call the GUI, and act as a
// top-level receptacle for exceptions.

#ifdef WIN32
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmd, int nShow)
#else
int main()
#endif
	
{
    Logger::clean();
    Logger::log("Main") << "Session started.";
    
    try {
	GUIPlugin *gui; gui = (GUIPlugin*)PluginRequest("UI");
	gui->run();
	PluginUnrequest("UI", 1);
    }
    catch(Exception &e)
    {
        e.Report();
        return 1;
    }

    Logger::log("Main") << "Session ended.\n";
    return 0;
}

/*** EOF: dsemu.cpp ******************************************************/

