/**************************************************************************
* DSemu - The Next Generation                                             *
* Error handling: Exception class definition [err.h]                      *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
**************************************************************************/
#ifndef __ERR_H_
#define __ERR_H_

#include <string>

#define ERR_UNKNOWN         0x0001

class Exception
{
    // An exception can be generated on type alone, or on
    // type/module/message.
    public:
        Exception();
        Exception(int);
        Exception(int, std::string, std::string);
        void Report();
        void Log();
    private:
        int type;
        std::string module;
        std::string msg;
};

#endif//__ERR_H_

/*** EOF: err.h **********************************************************/

