#ifndef __NDSHEAD_H_
#define __NDSHEAD_H_

#include <string>
#include "datadefs.h"

class NDShead {
    public:
	struct {
            u8 title[12], code[4], manuf[2], unitcode;
            u8 devcode, cardsize, cardinfo[10], flags;

            u32 arm9src, arm9exec, arm9dest, arm9size;
            u32 arm7src, arm7exec, arm7dest, arm7size;

            u32 ftablesrc, ftablesize;
            u32 fdatasrc, fdatasize;

            u32 arm9osrc, arm9osize;
            u32 arm7osrc, arm7osize;
            u32 RESa, RESb;

            u32 bannersrc;
            u16 crcsec, timeout;
            u32 arm9unk, arm7unk;
            u8 RESc[8];
     
            u32 romsize, headsize;
            u8 RESd[56], logo[156];
            u16 crclogo, crchead;
            u8 RESe[160];
	} head;

	NDShead(std::string);     // From filename
	NDShead(u8*);             // From memory
	void print();
	
    private:
	void byteswap();
};

#endif//__NDSHEAD_H_

