/**************************************************************************
* DSemu - The Next Generation                                             *
* Null APU plugin: Class definition [nullapu.h]                           *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
**************************************************************************/

#include "defs.h"
#include "plgapu.h"
#include "plggui.h"
#include "datadefs.h"

// An implementation of the APU plugin interface.
class nullAPU : public APUPlugin
{
    public:
        nullAPU(std::string, REQPTR, UNREQPTR);
	~nullAPU();

        PLUGININFO *getinfo();
	void reset();
	void release();
	void status(int,int);

	void togglePause();
	
    private:
        //---Plugin-generic stuff
        std::string pName, pClass;
        REQPTR pRequest;
        UNREQPTR pUnrequest;
	static PLUGININFO pInfo;
       
        static std::string pluginName;
};

/*** EOF: nullapu.h ******************************************************/

