/**************************************************************************
* DSemu - The Next Generation                                             *
* Null GPU plugin: Class definition [nullgpu.h]                           *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
**************************************************************************/

#include "defs.h"
#include "plggpu.h"
#include "plggui.h"
#include "datadefs.h"

// An implementation of the GPU plugin interface.
class nullGPU : public GPUPlugin
{
    public:
        nullGPU(std::string, REQPTR, UNREQPTR);
	~nullGPU();

        PLUGININFO *getinfo();
	void reset();
	void release();
	void status(int,int);
	
	void setDisplay(u8*);
	
    private:
        //---Plugin-generic stuff
        std::string pName, pClass;
        REQPTR pRequest;
        UNREQPTR pUnrequest;
	static PLUGININFO pInfo;
       
        static std::string pluginName;
	static GUIPlugin *GUI;

	static void drawline(Plugin*);
	inline void line();
};

/*** EOF: nullgpu.h *******************************************************/

