/**************************************************************************
* DSemu - The Next Generation                                             *
* Plugin definitions: CPU interface [plgcpu.h]                            *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
**************************************************************************/

#ifndef __PLGCPU_H_
#define __PLGCPU_H_

#include <utility>
#include <map>
#include "datadefs.h"
#include "plgbase.h"

// Extending the base plugin interface.
class CPUPlugin : public Plugin
{
    public:
        virtual int exec(int) = 0;            // Execute given cycle count
        virtual void clockAdd(int) = 0;       // Add to internal clock
	virtual void setPC(u32) = 0;          // Change the PC from outside
        virtual void interrupt(int) = 0;      // Interrupt occurred
	
	virtual void dbgBkptToggle(u32) = 0;  // Toggle a breakpoint
	virtual std::map<u32, int> dbgBkptGet() = 0;   // Return bkpt map
};

#define PLUGIN_TYPE_CPU 1

#define ERR_CPU_INIT    0x0101  // Error initing CPU

// Possible types of CPU interrupt
#define CPU_INTERRUPT_NORMAL 0  // Standard interrupt

#endif//__PLGCPU_H_

/*** EOF: plgcpu.h *******************************************************/

