/**************************************************************************
* DSemu - The Next Generation                                             *
* Plugin definitions: GUI interface [plggui.h]                            *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
**************************************************************************/

#ifndef __PLGGUI_H_
#define __PLGGUI_H_

#include "plgbase.h"
#include "msgqueue.h"
#include "datadefs.h"

// Extending the base plugin interface.
class GUIPlugin : public Plugin
{
    public:
        virtual int run() = 0;                                             // Enter GUI loop
	virtual int subwinCreate(int, int, const char*, u32*) = 0;         // Create a window from another plugin
	virtual void subwinRefresh(int) = 0;                               // Refresh a given subwindow
	virtual uint64_t getTimestamp() = 0;                               // Where the GUI is, in clocks
	virtual void eventPush(u32, int, vfptr, void*) = 0;                // Push an event into the queue
};

#define PLUGIN_TYPE_GUI 4

#define ERR_GUI_INIT    0x0401
#define ERR_GUI_RENDER  0x0402

#endif//__PLGGUI_H_

/*** EOF: plggui.h *******************************************************/

