/**************************************************************************
* DSemu - The Next Generation                                             *
* Portable ARM9ES Core: Thumb opcode table [thumb9-olut.cpp]              *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
**************************************************************************/

#include "arm9es.h"

// The opcode table, indexed by bits 15-8 of the opcode.
const ARM9ES::opfptr ARM9ES::TLUT[256]={
    //0x00
    topLSLimm    ,
    topLSLimm    ,
    topLSLimm    ,
    topLSLimm    ,
    topLSLimm    ,
    topLSLimm    ,
    topLSLimm    ,
    topLSLimm    ,
    topLSRimm    ,
    topLSRimm    ,
    topLSRimm    ,
    topLSRimm    ,
    topLSRimm    ,
    topLSRimm    ,
    topLSRimm    ,
    topLSRimm    ,

    //0x10
    topASRimm    ,
    topASRimm    ,
    topASRimm    ,
    topASRimm    ,
    topASRimm    ,
    topASRimm    ,
    topASRimm    ,
    topASRimm    ,
    topADDreg    ,
    topADDreg    ,
    topSUBreg    ,
    topSUBreg    ,
    topADDimm3   ,
    topADDimm3   ,
    topSUBimm3   ,
    topSUBimm3   ,

    //0x20
    topMOVimm8r0 ,
    topMOVimm8r1 ,
    topMOVimm8r2 ,
    topMOVimm8r3 ,
    topMOVimm8r4 ,
    topMOVimm8r5 ,
    topMOVimm8r6 ,
    topMOVimm8r7 ,
    topCMPimm8r0 ,
    topCMPimm8r1 ,
    topCMPimm8r2 ,
    topCMPimm8r3 ,
    topCMPimm8r4 ,
    topCMPimm8r5 ,
    topCMPimm8r6 ,
    topCMPimm8r7 ,

    //0x30
    topADDimm8r0 ,
    topADDimm8r1 ,
    topADDimm8r2 ,
    topADDimm8r3 ,
    topADDimm8r4 ,
    topADDimm8r5 ,
    topADDimm8r6 ,
    topADDimm8r7 ,
    topSUBimm8r0 ,
    topSUBimm8r1 ,
    topSUBimm8r2 ,
    topSUBimm8r3 ,
    topSUBimm8r4 ,
    topSUBimm8r5 ,
    topSUBimm8r6 ,
    topSUBimm8r7 ,

    //0x40
    topDPg1      ,
    topDPg2      ,
    topDPg3      ,
    topDPg4      ,
    topADDH      ,
    topCMPH      ,
    topMOVH      ,
    topBXreg     ,
    topLDRPCr0   ,
    topLDRPCr1   ,
    topLDRPCr2   ,
    topLDRPCr3   ,
    topLDRPCr4   ,
    topLDRPCr5   ,
    topLDRPCr6   ,
    topLDRPCr7   ,

    //0x50
    topSTRreg    ,
    topSTRreg    ,
    topSTRHreg   ,
    topSTRHreg   ,
    topSTRBreg   ,
    topSTRBreg   ,
    topLDRSBreg  ,
    topLDRSBreg  ,
    topLDRreg    ,
    topLDRreg    ,
    topLDRHreg   ,
    topLDRHreg   ,
    topLDRBreg   ,
    topLDRBreg   ,
    topLDRSHreg  ,
    topLDRSHreg  ,

    //0x60
    topSTRimm5   ,
    topSTRimm5   ,
    topSTRimm5   ,
    topSTRimm5   ,
    topSTRimm5   ,
    topSTRimm5   ,
    topSTRimm5   ,
    topSTRimm5   ,
    topLDRimm5   ,
    topLDRimm5   ,
    topLDRimm5   ,
    topLDRimm5   ,
    topLDRimm5   ,
    topLDRimm5   ,
    topLDRimm5   ,
    topLDRimm5   ,

    //0x70
    topSTRBimm5  ,
    topSTRBimm5  ,
    topSTRBimm5  ,
    topSTRBimm5  ,
    topSTRBimm5  ,
    topSTRBimm5  ,
    topSTRBimm5  ,
    topSTRBimm5  ,
    topLDRBimm5  ,
    topLDRBimm5  ,
    topLDRBimm5  ,
    topLDRBimm5  ,
    topLDRBimm5  ,
    topLDRBimm5  ,
    topLDRBimm5  ,
    topLDRBimm5  ,

    //0x80
    topSTRHimm5  ,
    topSTRHimm5  ,
    topSTRHimm5  ,
    topSTRHimm5  ,
    topSTRHimm5  ,
    topSTRHimm5  ,
    topSTRHimm5  ,
    topSTRHimm5  ,
    topLDRHimm5  ,
    topLDRHimm5  ,
    topLDRHimm5  ,
    topLDRHimm5  ,
    topLDRHimm5  ,
    topLDRHimm5  ,
    topLDRHimm5  ,
    topLDRHimm5  ,

    //0x90
    topSTRSPr0   ,
    topSTRSPr1   ,
    topSTRSPr2   ,
    topSTRSPr3   ,
    topSTRSPr4   ,
    topSTRSPr5   ,
    topSTRSPr6   ,
    topSTRSPr7   ,
    topLDRSPr0   ,
    topLDRSPr1   ,
    topLDRSPr2   ,
    topLDRSPr3   ,
    topLDRSPr4   ,
    topLDRSPr5   ,
    topLDRSPr6   ,
    topLDRSPr7   ,

    //0xA0
    topADDPCr0   ,
    topADDPCr1   ,
    topADDPCr2   ,
    topADDPCr3   ,
    topADDPCr4   ,
    topADDPCr5   ,
    topADDPCr6   ,
    topADDPCr7   ,
    topADDSPr0   ,
    topADDSPr1   ,
    topADDSPr2   ,
    topADDSPr3   ,
    topADDSPr4   ,
    topADDSPr5   ,
    topADDSPr6   ,
    topADDSPr7   ,

    //0xB0
    topADDSPimm7 ,
    topUND       ,  // Misc map: unallocated
    topUND       ,  // Misc map: unallocated
    topUND       ,  // Misc map: unallocated
    topPUSH      ,
    topPUSHlr    ,
    topUND       ,  // Misc map: unallocated
    topUND       ,  // Misc map: unallocated
    topUND       ,  // Misc map: unallocated
    topUND       ,  // Misc map: unallocated
    topUND       ,  // Misc map: unallocated
    topUND       ,  // Misc map: unallocated
    topPOP       ,
    topPOPpc     ,
    topBKPT      ,
    topUND       ,  // Misc map: unallocated

    //0xC0
    topSTMIAr0   ,
    topSTMIAr1   ,
    topSTMIAr2   ,
    topSTMIAr3   ,
    topSTMIAr4   ,
    topSTMIAr5   ,
    topSTMIAr6   ,
    topSTMIAr7   ,
    topLDMIAr0   ,
    topLDMIAr1   ,
    topLDMIAr2   ,
    topLDMIAr3   ,
    topLDMIAr4   ,
    topLDMIAr5   ,
    topLDMIAr6   ,
    topLDMIAr7   ,

    //0xD0
    topBEQ       ,
    topBNE       ,
    topBCS       ,
    topBCC       ,
    topBMI       ,
    topBPL       ,
    topBVS       ,
    topBVC       ,
    topBHI       ,
    topBLS       ,
    topBGE       ,
    topBLT       ,
    topBGT       ,
    topBLE       ,
    topUND       ,  // Covered by unconditional
    topSWI       ,

    //0xE0
    topB         ,
    topB         ,
    topB         ,
    topB         ,
    topB         ,
    topB         ,
    topB         ,
    topB         ,
    topBLXoff    , 
    topBLXoff    , 
    topBLXoff    , 
    topBLXoff    , 
    topBLXoff    , 
    topBLXoff    , 
    topBLXoff    , 
    topBLXoff    , 

    //0xF0
    topBLsetup   ,
    topBLsetup   ,
    topBLsetup   ,
    topBLsetup   ,
    topBLsetup   ,
    topBLsetup   ,
    topBLsetup   ,
    topBLsetup   ,
    topBLoff     ,
    topBLoff     ,
    topBLoff     ,
    topBLoff     ,
    topBLoff     ,
    topBLoff     ,
    topBLoff     ,
    topBLoff     ,
};

/*** EOF: thumb9-olut.cpp ************************************************/

