/**************************************************************************
* DSemu - The Next Generation                                             *
* Fltk user interface: Plugin-specific windows [uifltk-sub.cpp]           *
* Copyright Imran Nazar, 2005; released under the BSD public licence.     *
* Fltk used under the terms of the LGPL.                                  *
**************************************************************************/

#include <FL/Fl.h>
#include "uifltk.h"

// Initialise window. All we do is make the window, and set it hidden.
UIFltk::UI::SubWindow::SubWindow(int w, int h, void *t)
	: Fl_Double_Window(w,h,"Fill this")
{
    mainWnd = (Fl_Window*)t;
    xdim = w; ydim = h;

    visible=0;
    hide();
}

// Shut down the window: just hide it
UIFltk::UI::SubWindow::~SubWindow()
{
    hide();
}
	
// Handle the hide event by telling the main UI about it.
int UIFltk::UI::SubWindow::handle(int e)
{
    int ret = Fl_Window::handle(e);
    switch(e)
    {
        case FL_HIDE:
            Fl::handle(winID, mainWnd);
	    break;
    }
    return ret;
}

// Every plugin window is just a wrapper for a framebuffer, so the draw
// function simply needs to dump this buffer on screen.
void UIFltk::UI::SubWindow::draw()
{
    Fl_Double_Window::draw();
    fl_draw_image((u8*)buffer, 0,0, xdim,ydim, 4);
}

/*** EOF: uifltk-sub.cpp *************************************************/

